//------------------------------------------------------
// module  : FunctionHDR.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions de reservations memoires utiles 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <new.h>

#include "FunctionHDR.h"


//-------------------------//
//-- Matrice de Flottant --//
//-------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de float
//----------------------------------------------------------
float**** fmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  float**** matrix;

  matrix=new float***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=fmatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de float
//----------------------------------------------------------
void free_fmatrix_4d(float**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_fmatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//--------------------//
//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int*** pmatl1,float*** pmatl2,int lgth,int wdth,int nbcoul)
{
 int i,j,k;

  for(k=0;k<nbcoul;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    pmatl1[k][i][j]=(int)(pmatl2[k][i][j]+0.49); 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float*** pmatl1,float*** pmatl2,int lgth,int wdth,int nbcoul)
{
 int i,j,k;

  for(k=0;k<nbcoul;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    pmatl1[k][i][j]=pmatl2[k][i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 //Initialisation
 max=-1000000.0;
 min=100000000;

 //Recherche du min
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 //plus min
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 //Recherche du max
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 //Recalibre la matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

//---------------------------------------------------
// Recal                                  
//---------------------------------------------------
void Recal(float*** mat,int lgth,int wdth)
{
 int i,j,k;
 float max,min;
 float tmp;

 //Boucle
 for(k=0;k<3;k++)
   {
    max=-10000;
    min=10000;

    //>min/max
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[k][i][j]<min) min=mat[k][i][j];
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[k][i][j]>max) max=mat[k][i][j];

    //>Debug
    printf("[min=%.1f max=%.1f]",min,max);
    fflush(stdout);
  
    //>Recalibre
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max) 
      { tmp=((float)mat[k][i][j]-(float)min)*(GREY_LEVEL/(float)(max-min));
        if (tmp<0)    tmp=0.0;
        if (tmp>255) tmp=255.0; 
        mat[k][i][j]=tmp; }  
   }     
}

//---------------------------------------------------
// Recal n%                                  
//---------------------------------------------------
void Recal(float** mat,int lgth,int wdth,float pourc)
{
  int i,j,k;
  float nbpix;
  float nb;
  float max,min;

 //>Parametre
 nbpix=(int)((pourc*(lgth*wdth)/100.0));
  
 //>AllocationMemoire
 float* Vct=fmatrix_allocate_1d(255);
 
 //>Recalage [0-255]
 Recal(mat,lgth,wdth);

 //>Histo
 for(k=0;k<255;k++)  Vct[k]=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Vct[(int)(mat[i][j])]++;

 //>max/min
 min=0; max=255;
 for(nb=0.0,k=255;k>=0;k--) { nb+=Vct[k]; if (nb>nbpix) { max=k+1; break; } }
 for(nb=0.0,k=0;k<255;k++)  { nb+=Vct[k]; if (nb>nbpix) { min=k-1; break; } }

 //>Info
  printf("\n >> p=%.1f <%d pix>  [min=%.1f::max=%.1f]",pourc,(int)nbpix,min,max);
  fflush(stdout);

 //Recalage
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { if (mat[i][j]>max) mat[i][j]=max;
     if (mat[i][j]<min) mat[i][j]=min; }

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]-=min;

 max=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[i][j]>max) max=mat[i][j];
 //printf(" [max=%.0f]",max);
 //fflush(stdout);

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max) mat[i][j]*=((float)(GREY_LEVEL/max));  

 //Info
 max=0.0; min=255.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { if (mat[i][j]>max) max=mat[i][j]; 
     if (mat[i][j]<min) min=mat[i][j]; }
 
 //>LiberationMemoire
 if (Vct) free_fmatrix_1d(Vct);
}

//---------------------------------------------------
// RecalI                                  
//---------------------------------------------------
void RecalI(float** mat,int lgth,int wdth,float min,float max)
{
 int i,j; 
 float scale;
 scale=max-min;

 //Recal [0-255]
 Recal(mat,lgth,wdth);
 
 //Recal [min-max]
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]*=scale/255.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]+=min; 
}

//----------------------------------------------------------
// ComputeMean
//----------------------------------------------------------
float ComputeMean(float** mat,int lgth,int wdth)
{
 int i,j;
 float Moy;

 Moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Moy+=mat[i][j]; 
 Moy/=(lgth*wdth);

 return Moy;
}

//----------------------------------------------------------
// ComputeDiff
//----------------------------------------------------------
float ComputeDiff(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;
 float Diff;

 Diff=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Diff+=fabs(mat1[i][j]-mat2[i][j]);
 Diff/=(lgth*wdth);

 return Diff;
}

//----------------------------------------------------------
// Stat           
//----------------------------------------------------------     
void Stat(float** Img,int lgth,int wdth)
{
 int i,j;
 float min,max,moy; 

 //Stats
 min=10000000.0;
 max=-10000000.0;
 moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { moy+=Img[i][j];
      if(min>Img[i][j]) min=Img[i][j]; 
      if(max<Img[i][j]) max=Img[i][j];  }
  moy/=(lgth*wdth);
  printf("\n Stat::[min=%.1f | max=%.1f | Moy=%.1f]",min,max,moy);
  fflush(stdout);
}

//----------------------//
//----------------------//
//-- FILE -PGM/PPM------//
//----------------------//
//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,char* Com,int*** matrvb,int lgth,int wdth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n Sauvegarde dans -> %s au format %s",buff,"ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# %s \n",Com);
  fprintf(fuser,"%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,char* Com,float*** matrvb,int lgth,int wdth)
 {
   int i,j,k;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n Sauvegarde dans -> %s au format %s",buff,"ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# %s \n",Com);
  fprintf(fuser,"%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { matrvb[k][i][j]=(int)(matrvb[k][i][j]+0.49);
      if (matrvb[k][i][j]<0)   matrvb[k][i][j]=0;
      if (matrvb[k][i][j]>255) matrvb[k][i][j]=255; }      

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { fprintf(fuser,"%c",(char)matrvb[0][i][j]);
      fprintf(fuser,"%c",(char)matrvb[1][i][j]);
      fprintf(fuser,"%c",(char)matrvb[2][i][j]); }
       
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde dans -> %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//--------------------------------
//--------------------------------
//----GRADIENT -------------------
//--------------------------------
//----------------------------------------------------------
// AddMatrix   <matres=mata+fact*matb>               
//----------------------------------------------------------     
void AddMatrix(float** matout,float** matin1,float fact,float** matin2,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     matout[i][j]=matin1[i][j]+(fact*matin2[i][j]);
}

//------------------------------------------------------------------------
// ComputeBeta  
// <Grad_J(x[n]-Grad_J(x[n-1]),Grad_J(x[n]>/<Grad_J(x[n-1]),Grad_J(x[n-1])>  
//------------------------------------------------------------------------  
float ComputeBeta(float** ImGrd,float** ImGrdp,int lgth, int wdth)
{
 int i,j;
 float Num,Denum;
 float Res=0.0;

 //AllocationMemoire
 float** ImTmp=fmatrix_allocate_2d(lgth,wdth);

 // ImRes <-- Grad_J(x[n])-Grad_J(x[n-1])
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImTmp[i][j]=ImGrd[i][j]-ImGrdp[i][j];

 // Numerateur & Denumerateur
 Num=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Num+=ImTmp[i][j]*ImGrd[i][j];
 Denum=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Denum+=CARRE(ImGrdp[i][j]);

 //Liberation Memoire
 if (ImTmp) free_fmatrix_2d(ImTmp);

 //Retour
 if (Denum) Res=Num/Denum;
 return Res;
}

//----------------------------------------------------------
// MultMatrix   <matout=matin1*matin2>               
//----------------------------------------------------------     
void MultMatrix(float** matout,float Beta,float** matin,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=Beta*matin[i][j];
}

//----------------------------------------------------------
// InitMatrix
//----------------------------------------------------------     
void InitMatrix(float** mat,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=0.0;
}

//--------------------//
//--------------------//
//---- HDR-IMAGES ----//
//--------------------//
//----------------------------------------------------------
// CopyHdrInMat
//----------------------------------------------------------
void CopyVctHdrInMatImg(float* VctHdr,float*** MatImg,int lgth,int wdth)
{
  int i,j,k,l,m;

  //Copy
  for(k=0;k<(3*wdth*lgth);k++)
   { l=k/3;
     m=k%3;
     i=l/wdth;
     j=l%wdth;
     MatImg[m][i][j]=VctHdr[k]; }
}

//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }

//----------------------------------------------------------------
//  quickSort
//----------------------------------------------------------------
void swap(float* a,float* b)
{
  float t=*a; *a=*b; *b=t;
}

void sort(float* arr,int beg,int end)
{
  if (end>beg+1)
  {
    float piv=arr[beg];
    int l=beg+1,r=end;
    while (l<r)
    {
      if (arr[l]<=piv) l++;
      else swap(&arr[l],&arr[--r]);
    }
    swap(&arr[--l],&arr[beg]);
    sort(arr,beg,l);
    sort(arr,r,end);
  }
}

//----------------------------------------------------------------
//  quickSort
//  ---------     Arr[l][c]   :: Arr[l][0] a classer
//                            :: l \in [beg::end]
//                            :: c \in [0::Nb]
//----------------------------------------------------------------
void sort(float** arr,int beg,int end,int Nb)
{
 int k;

 //>Sort
 if (end>beg+1)
  {
    float piv=arr[beg][0];
    int l=beg+1,r=end;
    while (l<r)
    {
      if (arr[l][0]<=piv) l++;  
      else { r--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[r][k]); }
    }
    l--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[beg][k]);
    sort(arr,beg,l,Nb);
    sort(arr,r,end,Nb);
  }
} 

//----------------------------------------------------------
// FuncGauss
//----------------------------------------------------------
float funcgauss(float pix,float moy,float var)
{
return (float)((1/(sqrt(2*PI*var)))*exp(-1*(CARRE((float)pix-moy))/(2*var)));
}
