//------------------------------------------------------
// module  : FunctionHDR.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions  

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <new.h>
#include <time.h>

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
#define TROIS 3
#define QUATRE 4
#define CINQ   5

#define NCHAR 200
#define PI  3.14159
#define GREY_LEVEL 255

#define MILLE             1000
#define MILLION        1000000
#define DIXMILLIONS   10000000
#define BILLION     1000000000
#define BIGNUMBER    100000000

#define CARRE(X)   ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;
#define ByteSwap5(x) ByteSwap((unsigned char *) &x,sizeof(x))

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//>Matrix Allocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
float**** fmatrix_allocate_4d(int,int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_fmatrix_4d(float****,int,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);

//>Matrix Gestion
void  CopyMat(int***,float***,int,int,int);  
void  CopyMat(float***,float***,int,int,int); 
void  CopyMat(float**,float**,int,int); 
void  Recal(float**,int,int); 
void  Recal(float***,int,int);
void  Recal(float**,int,int,float); 
void  RecalI(float**,int,int,float,float);
float ComputeMean(float**,int,int); 
float ComputeDiff(float**,float**,int,int); 
void  Stat(float**,int,int);

//>File PGM/PPM
void SaveImagePpm(char*,char*,char*,int***,int,int); 
void SaveImagePpm(char*,char*,char*,float***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);

//>Gradient 
void  AddMatrix(float**,float**,float,float**,int,int);
float ComputeBeta(float**,float**,int,int);
void  MultMatrix(float**,float,float**,int,int);
void  InitMatrix(float**,int,int);

//-------------
// HDR --------
//-------------
void  CopyVctHdrInMatImg(float*,float***,int,int);
float randomize(void);
void  swap(float*,float*);
void  sort(float*,int,int); 
void  sort(float**,int,int,int);
float funcgauss(float,float,float);
