//---------------------------------------------------
// module  : f_DisplayHDR.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "DisplayHDR.h"

//------------------------------------------------
// METHODES DE LA CLASSE DISPLAYHDR  -------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe DisplayHDR
//----------------------------------------------------------
DisplayHDR::DisplayHDR(int lgth,int wdth)           
 {
  //Initialisation
  length=lgth;
  width=wdth;

  //Allocation Memoire Matrice  
  ImgCoulf=fmatrix_allocate_3d(TROIS,length,width);
  ImgCoul=imatrix_allocate_3d(TROIS,length,width);

  Img1=fmatrix_allocate_2d(length,width);
  Img2=fmatrix_allocate_2d(length,width);
  Img3=fmatrix_allocate_2d(length,width);
  Img4=fmatrix_allocate_2d(length,width);
  Img5=fmatrix_allocate_2d(length,width); 
  Img6=fmatrix_allocate_2d(length,width); 
  Img7=fmatrix_allocate_2d(length,width);
  Img8=fmatrix_allocate_2d(length,width);
  Img9=fmatrix_allocate_2d(length,width);

  //Parametre
  NbIter=NBITER;
 }

//----------------------------------------------------------
// Destructeur de la classe DisplayHyper
//----------------------------------------------------------
DisplayHDR::~DisplayHDR()
{ 
  //Libere Memoire Matrice 
  if (ImgCoulf)   free_fmatrix_3d(ImgCoulf,TROIS);
  if (ImgCoul)    free_imatrix_3d(ImgCoul,TROIS);; 

  if (Img1)       free_fmatrix_2d(Img1); 
  if (Img2)       free_fmatrix_2d(Img2);
  if (Img3)       free_fmatrix_2d(Img3);
  if (Img4)       free_fmatrix_2d(Img4);
  if (Img5)       free_fmatrix_2d(Img5);
  if (Img6)       free_fmatrix_2d(Img6);
  if (Img7)       free_fmatrix_2d(Img7);
  if (Img8)       free_fmatrix_2d(Img8);
  if (Img9)       free_fmatrix_2d(Img9);
}

//------------//
//--METHODES--//
//------------//
//----------------------------------------------------------
//
// Compression HDR
//
//     ImgTmp1 :: ImgHDR raw[0-1]
//     ImgTmp2 :: ImgHDR_raw[0-1]_Lum
//     ImgTmp3 :: ImgHDR_raw[0-1]_LumSpec :: ImgS1init
//
//     ImgTmp5 :: DEBUG
//
//     ImgS1init :: Luminance compressee InitGrad
//     ImgS1     :: Luminance compressee
//    
//----------------------------------------------------------    
void DisplayHDR::Display_HDR()
{

 //>Loading HDR Img.
 //=================
 Chrono  chrono; chrono.reset();
 printf("\n CHARGEMENT HDR RGBE Img. [%s]",Name_Img);
 fflush(stdout);
 FILE* f=fopen(Name_Img,"rb");
 RGBE_ReadHeader(f,&width,&length,NULL);
 fflush(stdout);
 float* image=(float *)malloc(sizeof(float)*3*width*length);
 RGBE_ReadPixels_RLE(f,image,width,length);
 fclose(f);
 TimeSec=chrono.elapsed(SECOND); chrono.print(); 

 //>Img Too Big>>NbNeighb=2
 //========================
 if ((width*length)>2000000)  
   {  if (NEIGHB>2) NewNeighb=2; 
      else NewNeighb=NEIGHB;
      Tau/=2;    
      printf(" Img. very Big! >> Nb Neighb. CARRE(2n+1)=%d",CARRE((2*NewNeighb)+1)); 
      fflush(stdout);  }
 else NewNeighb=NEIGHB;

 //>WithBigMemory
 //NewNeighb=NEIGHB;

 //>Information
 //============
 printf("\n ---------");
 printf("\n IMAGE: [%s]",Name_Img);
 printf(" [Ext:%s]",Extension);
 printf("  Size:[lgth:%d | wdth:%d]",length,width);
 printf("\n ---------");
 printf("\n Nb Neighb. CARRE(2n+1) ..[%d]",CARRE((2*NewNeighb)+1));
 printf("\n VarGradMax ..............[%.4f]",Tau);
 printf("\n ---------");
 printf("\n GradientStep.....[%.3f]",StGr);
 printf("\n NbIterMax........[%d]",NbIter);
 printf("\n ---------\n");
 fflush(stdout);

 //>Parametre
 //==========
 StGrInit=StGr;

 //>AllocationMemoire
 //==================
 float***  ImgTmp1=fmatrix_allocate_3d(TROIS,length,width);
 float***  ImgTmp2=fmatrix_allocate_3d(TROIS,length,width); 
 float***  ImgTmp3=fmatrix_allocate_3d(TROIS,length,width);
 float***  ImgTmp5=fmatrix_allocate_3d(TROIS,length,width); 
 float**   ImgS1init=fmatrix_allocate_2d(length,width);
 float**   ImgS1=fmatrix_allocate_2d(length,width);


 //>Load HdrImg | Luminance | Specification
 //====================================================

 //>HDR_raw[0-1] > ImgTmp1 | Luminance > ImgTmp2[0]
 CopyVctHdrInMatImg(image,ImgTmp1,length,width);
 HDR_ConvertImgRGBToLum(ImgTmp1,ImgTmp2[0],length,width);

 //>HDR_raw[0-1]_LumSpecifHisto :: ImgTmp3[0]  > ImgS1init
 HDR_ExactSpecifGaussModel(ImgTmp2[0],ImgTmp3[0],length,width);
 CopyMat(ImgS1init,ImgTmp3[0],length,width);

 //>>>>DEBUG<<<<
 if (0) { CopyMat(ImgTmp5[0],ImgS1init,length,width);
          Recal(ImgTmp5[0],length,width);
          SaveImagePgm("","ImageInitLuminance",ImgTmp5[0],length,width);}

 //>>>>DEBUG<<<<
 if (0) HDR_ComputeHisto(ImgS1init,length,width);


 //========================================================================
 //>Conjugate Gradient Descent
 //
 //         (float** HdrImg,int lgth,int wdth, int SzW,int NbCnx,
 //          float** ImgRes,int Scale,int NbIter,float** ImgInit)
 //=========================================================================
 HDR_ComputeConjGradDesc_(ImgTmp2[0],length,width,(2*NewNeighb)+1,CARRE((2*NewNeighb)+1),ImgS1,NbIter,ImgS1init);

  TimeSec=chrono.elapsed(SECOND); chrono.print();
  HDR_FillInfoProcess();

  //>>>>DEBUG<<<<
  if (0) HDR_ComputeHisto(ImgS1,length,width);

  //>>>>DEBUG<<<<
  if (0) { CopyMat(ImgTmp5[0],ImgS1,length,width);
           Recal(ImgTmp5[0],length,width);
           SaveImagePgm("","ImageLuminance",ImgTmp5[0],length,width); }
 //========/End ==============================================================

 //===========================================================================
 //>Color Treatment
 // 
 // (float*** HdrImg,float** HdrLumIn,float** HdrLumOut....)
 //  HdrImg    : R,V,B Img HDR non compresse
 //  HdrLumIn  : HdrImg Luminance non compresse [0::1] 
 //  HdrLumOut : HdrImg Luminance compresse
 //============================================================================
 HDR_BuiltColorCompressedImg(ImgTmp1,ImgTmp2[0],ImgS1,length,width,ImgCoulf,SATHDR);

 //>>>>DEBUG<<<<
 if (0) { for(int k=0;k<TROIS;k++) HDR_Stat(ImgCoulf[k],length,width); }
 //=======/End==================================================================

 //>ScreenVisu
 //===========
 CopyMat(ImgCoul,ImgCoulf,length,width,TROIS);
  
 //>Sauvegarde
 //===========
 if (flag_save)
    { printf("\n  Sauvegarde");
      fflush(stdout);
      if (FLAG_NAMEWITHCOM) SaveImagePpm(Name_Img,InfoProcess,InfoProcess,ImgCoulf,length,width); 
      else SaveImagePpm(Name_Img,"_out",InfoProcess,ImgCoulf,length,width); }

 //>Liberation Memoire
 //===================
 if (ImgTmp1)  free_fmatrix_3d(ImgTmp1,TROIS); 
 if (ImgTmp2)  free_fmatrix_3d(ImgTmp2,TROIS);
 if (ImgTmp3)  free_fmatrix_3d(ImgTmp3,TROIS); 
 if (ImgTmp5)  free_fmatrix_3d(ImgTmp5,TROIS);
 if (ImgS1)      free_fmatrix_2d(ImgS1);
 if (ImgS1init)  free_fmatrix_2d(ImgS1init);
}

