//---------------------------------------------------
// module  : f_DisplayHDR2.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------
//
//________________
//_____ HDR ______
//________________
//________________
//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "DisplayHDR.h"


//-----------------------------------------------
//-----------------------------------------------
//METHODES --------------------------------------
//-----------------------------------------------
//-----------------------------------------------
//=================================
//=================================
//  GRADIENT 
//=================================
//=================================
//----------------------------------------------------------
// HDR_ComputeConjGradDesc_
//----------------------------------------------------------
//
// HDR <opt> >>  Multiresolution Descente Gradient Conjugue 
//               <HDR image format rgbe>
//
// float** HdrImg :: Luminance non compressee
//
//----------------------------------------------------------    
void DisplayHDR::HDR_ComputeConjGradDesc_(float** HdrImg,int lgth,int wdth,
int SzW,int NbCnx,float** ImgRes,int NbIter,float** ImgInit)
{
 int NbConnex;

 //>Parametre
 NbConnex=NbCnx;

  //>Presentation
  printf("\n\n _______________________________");
  printf("\n ____HDR Conjugate Gradient_____");
  printf("\n _______________________________");
  printf("\n\n  >> Img   [Lgth=%d::Wdth=%d]",lgth,wdth);
  printf("\n  >> NbCnx [%d]",NbConnex);
  printf("\n  -----");
  printf("\n  >> StepGradient [%.3f]",StGr);
  printf("\n  >> NbIterMax    [%d]",NbIter);
  printf("\n  >> VarGradMax   [%.4f]",Tau);
  fflush(stdout);

  //>AllocationMemoire 
  float**  NonLocGrphDif=fmatrix_allocate_2d(NbConnex,(wdth*lgth));
  float*   NonLocGrphGst=fmatrix_allocate_1d(NbConnex);
  
  //>NonLocalMultiResGraph
  HDR_ComputeNonLocalGraphWindow_(HdrImg,lgth,wdth,NonLocGrphDif,NonLocGrphGst,SzW,NbCnx);
 
  //>ConjugateGradientDecente ImgRed>ImgRes
  HDR_ConjGradDesc_(ImgInit,ImgRes,lgth,wdth,NonLocGrphDif,NonLocGrphGst,NbCnx,NbIter);  
  RecalI(ImgRes,lgth,wdth,0.0,1.0);

 //Liberation Memoire
 if (NonLocGrphDif) free_fmatrix_2d(NonLocGrphDif);
 if (NonLocGrphGst) free_fmatrix_1d(NonLocGrphGst);
}

//----------------------------------------------------------
// HDR <opt> >> ComputeNonLocalGraphWindow_
//----------------------------------------------------------
//
// float** HdrImg :: Luminance non compressee
// int  lgth/wdth :: Longueur/Largeur originale
//
//
//---------------------------------------------------------- 
void DisplayHDR::HDR_ComputeNonLocalGraphWindow_(float** HdrImg,int lgth,int wdth,\
float** NonLocGrphDif,float* NonLocGrphGst,int SzW,int NbCnx)
{
 short int i,j,k,l;
 short int posc,posr;
 short int SzWdiv2;
 float Beta;
 float tmp;
 float gst;
 int cpt,nb;
 float ValMaxGrph;

 //Paramters
 SzWdiv2=(SzW/2);

 //Presentation
 printf("\n");  
 printf("\n  > Compute HDR__NonLocalGraph Window ");
 printf("\n  >>> HDR Img:[lgth:%d-wdth:%d]",lgth,wdth);
 printf("  | Window Sz :[%d]",SzW);
 printf("  |  Connections :[%d]",NbCnx);
 fflush(stdout);

 //Init_NonLocGrph 
 for(i=0;i<lgth;i++) 
     for(j=0;j<wdth;j++) 
         for(k=0;k<NbCnx;k++) NonLocGrphDif[k][(i*wdth)+j]=0.0; 
     
  //-----------------------------------------------
  //--NonLocal Graph ------------------------------
  //-----------------------------------------------
  ValMaxGrph=0;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      //>SearchInBigWindow[posr,posc]
      cpt=0; nb=0; 
      for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
          cpt++;

          posr=i-(SzWdiv2)+k;
          posc=j-(SzWdiv2)+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;

          //if (nb>=NbCnx) break;
 
          //>Beta::Abs(FirstOrderDiff)
          //--------------------------
          Beta=fabs(HdrImg[i][j]-HdrImg[posr][posc]);
          NonLocGrphDif[nb][(i*wdth)+j]=Beta;
                   
          //>Gst::NormInf
          //--------------- 
          if ((i==10)&&(j==10))
	     { tmp=MAX(fabs(i-posr),fabs(j-posc));
	       if (tmp) gst=1.0/(MAX(fabs(i-posr),fabs(j-posc))); 
               else gst=0.0;
               NonLocGrphGst[nb]=gst; }
                                 
          //>Incremente
	  nb++; 

         //>Stat
	 //if (ValMaxGrph<Beta) ValMaxGrph=Beta;           
	}   
     }//------------------------------------------

 //Specification d'Histogramme
 HDR_SpecHistoGradOnModel_M(NonLocGrphDif,NbCnx,lgth,wdth);
}

//----------------------------------------------------------
// HDR <opt> >>HDR_ConjGradDesc 
//----------------------------------------------------------
//
// x[n+1]=x[n]+StGr*d[n]
// 
//  d[n]=- Grad_J(x[n])
//       + <Grad_J(x[n])-Grad_J(x[n-1]),Grad_J(x[n])>/<Grad_J(x[n-1]),Grad_J(x[n-1])> d[n-1]
//
// Img,Img7,Img8 : Img Initiale :: Image_Nrj_init
// Img1          : x[n] puis ...x[n+1]
// Img2          : Grad_J(x[n])
// Img3          : Grad_J(x[n-1])
// Img4          : d[n]
// Img5          : d[n-1]
// Img9          : x[n+1]
//
// <<MODIF!!!>>
//
//----------------------------------------------------------    
void DisplayHDR::HDR_ConjGradDesc_(float** Img,float** ImgRes,int lgth,int wdth,\
float** NonLocGrphDif,float* NonLocGrphGst,int NbCnx,int NbIter)
{
 int k;
 int NbDiv;
 float nrj,nrj_prec,nrj_init,nrj_best;
 float Beta;

 //>Init
 CopyMat(Img1,Img,lgth,wdth);
 CopyMat(Img8,Img,lgth,wdth);
 CopyMat(Img7,Img,lgth,wdth);
 nrj=HDR_ComputeNrj_(Img8,lgth,wdth,NonLocGrphDif,NonLocGrphGst,NbCnx);
 nrj_prec=nrj;
 nrj_init=nrj;
 printf("\n\n    >  HDR_ConjGradDescente [NbIterMax=%d]",NbIter);  
 printf("[MoyImg=%.4f]",ComputeMean(Img,lgth,wdth));  
 printf("\n    >  <NrjInit=%.6f>",nrj);
 fflush(stdout);
 NrjImgInit=nrj_init;
 nrj_best=nrj_init;
 Beta=0.0;
 NbDiv=0;

 //>Flag_stop
 int FlagStop=0; 

 //Variance Init
 VarMagnitude=HDR_ComputeVARGrad(Img8,lgth,wdth);
 printf(" [Var=%.5f>>%.3f]",VarMagnitude,Tau); 
 fflush(stdout); 

 //>Conjugate Gradient Descent
 //===========================
 for(k=0;((k<=NbIter)&&(!FlagStop));k++)
   {
     //>Info
     printf("\n [%d]>  ",k); 
    
     // Img2 <-- Grad_J(x[k]) 
     HDR_DeriveNrj_(Img1,Img2,lgth,wdth,NonLocGrphDif,NonLocGrphGst,NbCnx);

     //-------------------------------------------
     // [k==0] SimpleGradient
     //-------------------------------------------
     //      > d[k] <-- Grad_J(x[k])    
     //      > x[k+1]=x[n]-StrGr*Grad_J(x[k]) 
     if (k==0) 
        { CopyMat(Img4,Img2,lgth,wdth);
          AddMatrix(Img9,Img1,-1.0*StGr,Img2,lgth,wdth); }

     //--------------------------------------------
     // [k!=0] Gradient Conjugue
     //-------------------------------------------- 
     //      > x[k+1]=x[k]-StGr*d[k]
     if (k) 
       {  Beta=ComputeBeta(Img2,Img3,lgth,wdth);
          MultMatrix(Img6,Beta,Img5,lgth,wdth);
          AddMatrix(Img4,Img2,-1.0,Img6,lgth,wdth);
          AddMatrix(Img9,Img1,-1.0*StGr,Img4,lgth,wdth); }

     //>Calcul Nrj 
     nrj_prec=nrj;
     nrj=HDR_ComputeNrj_(Img9,lgth,wdth,NonLocGrphDif,NonLocGrphGst,NbCnx);
     printf("<Nrj=%.6f>",nrj);
     fflush(stdout);

     //>Calcul Variance Hdr(Magnitude)
     if ((Tau<0.003)||((k>=(0.4*NbIter))&&(!(k%2))))
                 {  VarMagnitude=HDR_ComputeVARGrad(Img9,lgth,wdth);
                    printf(" [Var=%.5f]",VarMagnitude); 
                    fflush(stdout); }

    //>Record ImgBest>Img8 & NrjBest
    if ((nrj<nrj_prec)&&(nrj<nrj_best)) CopyMat(Img8,Img9,lgth,wdth);  
    if (nrj<nrj_best) nrj_best=nrj;
 
    //>STOP CRITERION
    //--------------------------------------
    //1--> VarGradMagnitude>Tau
    if (VarMagnitude>Tau)
      { FlagStop=1; printf("-STOP-"); fflush(stdout); }

    //2--> Nrj Increases 
    if  ((nrj>nrj_prec)||(isnan(nrj))||(nrj>nrj_best))
	 { CopyMat(Img9,Img8,lgth,wdth);
           StGr/=2.0;
           InitMatrix(Img5,lgth,wdth);
           NbDiv++;
           printf(" %d>NewStep=%.6f",NbDiv,StGr);
           k--;
           fflush(stdout); }
    //-------------------------------------  

    // x[k+1] --> x[k]  
    // Img3 <-- Grad_J(x[k-1]) 
    // Img5 <-- d[k-1]
    CopyMat(Img1,Img9,lgth,wdth);
    CopyMat(Img3,Img2,lgth,wdth);
    CopyMat(Img5,Img4,lgth,wdth);

    //End
    if ((NbDiv>4)||(k>NbIter)) break;  

   }//FIN_ALGO======================================

 //Enregistrement Nrj_finale[Img9] & Stabilite[Img9]
 NrjImg=nrj;
 NbIterFinal=k;
 
 VarMagnitude=HDR_ComputeVARGrad(Img9,lgth,wdth); 
 printf("\n   >> [Nrj:%.7f][Var=%.5f]",NrjImg,VarMagnitude);
 printf("        [MoyImg=%.4f]",ComputeMean(Img9,lgth,wdth)); 
 printf("[DiffImg=%.4f]\n",ComputeDiff(Img9,Img7,lgth,wdth));  

 //Transfert>ImgRes
 CopyMat(ImgRes,Img9,lgth,wdth);
}

//----------------------------------------------------------
// HDR <opt> >> HDR_DeriveNrj_
//----------------------------------------------------------
//
// DERIV= 4 g SUM_<s,t> (Xs -Xt) [ Beta-(Xs-Xt)^2 ]
// 
// <<MODIF>>
//  
//----------------------------------------------------------  
void DisplayHDR::HDR_DeriveNrj_(float** Img,float** ImgGrad,int lgth,int wdth,\
float** NonLocGrphDif,float* NonLocGrphGst,int NbCnx)
{
 int i,j,k;
 int posr,posc;
 float tmp;
 float xs,xt;
 float difx,gst;
 int nbp;
 int SzW;

 //Init
 SzW=(int)sqrt(NbCnx);
 
 //Boucle
 //====================================
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   {
     nbp=(i*wdth)+j;
     xs=Img[i][j];

     tmp=0.0;
     //>ForAllConnexion
     for(k=0;k<NbCnx;k++)
       { 
         HDR_GivePosPixel_(i,j,k,&posr,&posc,SzW,lgth,wdth);

         gst=NonLocGrphGst[k];
         xt=Img[posr][posc];
         difx=(xs-xt);
         tmp+=-4*gst*(CARRE(NonLocGrphDif[k][nbp])-CARRE(difx))*difx; }

     //>Record
     ImgGrad[i][j]=tmp/(float)NbCnx;
   } 
}

//----------------------------------------------------------
// HDR <opt> >> HDR_Compute NRJ_   
//----------------------------------------------------------
//
// NRJ = SUM_<st> g ( Beta^2 - (Xs-Xt)^2 )^2
//
//---------------------------------------------------------- 
float DisplayHDR::HDR_ComputeNrj_(float** Img,int lgth,int wdth,float** NonLocGrphDif,\
float* NonLocGrphGst,int NbCnx)
{
 int i,j,k;
 float totvr,TotalVar;
 int posr,posc;
 int nbp;
 float gst,dist;
 int SzW;

 //Init
 SzW=(int)sqrt(NbCnx);

 //Calcul NRJ
 //=====================================
 TotalVar=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     {
      totvr=0.0;
      for(k=0;k<NbCnx;k++)
        { nbp=(i*wdth)+j; 
          HDR_GivePosPixel_(i,j,k,&posr,&posc,SzW,lgth,wdth);

          dist=NonLocGrphDif[k][nbp];
          gst=NonLocGrphGst[k];

          totvr+=gst*CARRE(CARRE(dist)-CARRE(Img[i][j]-Img[posr][posc])); }

      TotalVar+=totvr/(float)NbCnx;
     }

 //Retour
 return TotalVar;
}

//----------------------------------------------------------
// HDR <opt> >> HDR_GivePosPixel_  
//----------------------------------------------------------
//
//----------------------------------------------------------
void DisplayHDR::HDR_GivePosPixel_(int posr,int posc,int NbC,int* row,int* col,int SzW,int lgth,int wdth)
{
 int RowInWnd,ColInWnd;
 int SzWd2;

 SzWd2=(int)(SzW/2);
 RowInWnd=(NbC/SzW)+posr-SzWd2; 
 ColInWnd=(NbC%SzW)+posc-SzWd2; 
 if (RowInWnd<0)         RowInWnd+=lgth;
 if (RowInWnd>(lgth-1))  RowInWnd-=lgth; 
 if (ColInWnd<0)         ColInWnd+=wdth;
 if (ColInWnd>(wdth-1))  ColInWnd-=wdth;
 (*row)=RowInWnd;
 (*col)=ColInWnd;
}

//=================================
//=================================
//  STOP CRITERION
//=================================
//=================================
//---------------------------------------------------------- 
// HDR_ComputeVARGrad 
//----------------------------------------------------------
//          
//----------------------------------------------------------
float DisplayHDR::HDR_ComputeVARGrad(float** HdrImg,int lgth,int wdth)
{
  int i,j,k;
  int nb;
  float MoyGrad,VarGrad;

 //AllocationMemory
 float*  VctMag=fmatrix_allocate_1d(3*lgth*wdth);
 float** HdrTmp=fmatrix_allocate_2d(lgth,wdth);

 for(k=0;k<3*lgth*wdth;k++) VctMag[k]=-1;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) HdrTmp[i][j]=HdrImg[i][j];
 RecalI(HdrTmp,lgth,wdth,0.0,1.0);

 //LoadMagnitude
 nb=0;
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { VctMag[nb++]=fabs(HdrTmp[i+1][j]-HdrTmp[i][j]);
     VctMag[nb++]=fabs(HdrTmp[i][j+1]-HdrTmp[i][j]);  
     VctMag[nb++]=fabs(HdrTmp[i+1][j+1]-HdrTmp[i][j]); }

 //>Moyenne Grad<Hdr>
 MoyGrad=0.0;
 for(nb=0,k=0;k<3*lgth*wdth;k++) if (VctMag[k]>0)
   { MoyGrad+=VctMag[k]; nb++; }    
 MoyGrad/=nb;

 //>Variance Grad<Hdr>
 VarGrad=0.0;
 for(nb=0,k=0;k<3*lgth*wdth;k++) if (VctMag[k]>0) 
 { nb++; VarGrad+=CARRE(VctMag[k]-MoyGrad); }
 VarGrad/=nb;

  //Liberation Memoire
 if (VctMag) free_fmatrix_1d(VctMag);
 if (HdrTmp) free_fmatrix_2d(HdrTmp);

 //Return 
 return VarGrad;
}

//=================================
//=================================
//  LUMINANCE & COLOR TREATMENT
//=================================
//=================================
//--------------------------------------------------
// HDR_ConvertImgRGBToLum
//--------------------------------------------------
void DisplayHDR::HDR_ConvertImgRGBToLum(float*** RGB,float** L,int lgth,int wdth)
{
 int i,j;

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   L[i][j]=(0.3*RGB[0][i][j])+(0.59*RGB[1][i][j]+0.11*RGB[2][i][j]); 
}

//---------------------------------------------------
// HDR_RecalWithSat                           
//---------------------------------------------------
void DisplayHDR::HDR_RecalWithSat(float** mat,int lgth,int wdth,int MaxVal,float pourc)
{
 int i,j,k;
 float nbpix;
 float nb;
 float max,min;

 //>Presentation
 if (MaxVal==255) printf("\n > Stretching [0::255] > PourcPixelsSaturated %.2f",pourc);
 if (MaxVal==1)   printf("\n > Stretching [0.0::1.0] > PourcPixelsSaturated %.2f",pourc);
 fflush(stdout);
 if (!((MaxVal!=255)||(MaxVal!=1))) { printf("Probleme"); exit(-1); }

 //>Recal
 if (MaxVal==1)  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]*=255.0;
 
 //>Parametre
 nbpix=(int)((pourc*(lgth*wdth)/100.0));
  
 //>AllocationMemoire
 float* Vct=fmatrix_allocate_1d(NBBIN_IMG);
 
 //>Recalage [0::255]
 Recal(mat,lgth,wdth);

 //>Histo
 for(k=0;k<NBBIN_IMG;k++)  Vct[k]=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Vct[(int)(mat[i][j])]++;

 //>max/min
 min=0; max=NBBIN_IMG-1;
 for(nb=0.0,k=(NBBIN_IMG-1);k>=0;k--) { nb+=Vct[k]; if (nb>nbpix) { max=k+1; break; } }
 for(nb=0.0,k=0;k<(NBBIN_IMG-1);k++)  { nb+=Vct[k]; if (nb>nbpix) { min=k-1; break; } }

 //>Info
 printf(" > pourcentage=%.1f <%d pixels>  [min=%.1f::max=%.1f]",pourc,(int)nbpix,min,max);
 fflush(stdout);

 //Recalage
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { if (mat[i][j]>max) mat[i][j]=max;
     if (mat[i][j]<min) mat[i][j]=min; }

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]-=min;
 max=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[i][j]>max) max=mat[i][j];
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max) mat[i][j]*=((float)((NBBIN_IMG)/max));  
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[i][j]>(NBBIN_IMG-1)) mat[i][j]=(NBBIN_IMG-1);

 //>Recal
 if (MaxVal==1.0) RecalI(mat,lgth,wdth,0.0,1.0);
 
 //>LiberationMemoire
 if (Vct) free_fmatrix_1d(Vct);
}

//---------------------------------------------------------- 
// HDR_BuiltColorCompressedImg 
//----------------------------------------------------------
//
//  HdrImg    : R,V,B Img HDR non compresse
//  HdrLumIn  : HdrImg Luminance non compresse [0::1] 
//  HdrLumOut : HdrImg Luminance compresse
//
//  <<MODIF>>
//          
//----------------------------------------------------------
void DisplayHDR::HDR_BuiltColorCompressedImg(float*** HdrImg,float** HdrLumIn,float** HdrLumOut, \
int lgth,int wdth,float*** ImgCoul,float sat)
{ 
 int i,j,k;
 float tmp;

 //Presentation
 printf("\n > ColorModel -1-");
 fflush(stdout);

 //>Conversion
 //=================
 for(k=0;k<TROIS;k++)
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
       { tmp=0.0;
         if (HdrLumIn[i][j]) tmp=HdrImg[k][i][j]/(0.00001+HdrLumIn[i][j]);
	 ImgCoul[k][i][j]=powf(tmp,sat)*HdrLumOut[i][j]; }

 //Recalage [0::255] de RVB
 //========================
 HDR_RecalWithSat(ImgCoul[0],lgth,wdth,255,PIXSAT);
 HDR_RecalWithSat(ImgCoul[1],lgth,wdth,255,PIXSAT);
 HDR_RecalWithSat(ImgCoul[2],lgth,wdth,255,PIXSAT); 
}

//---------------------------------------------------------- 
// HDR_BuiltColorCompressedImg 
//----------------------------------------------------------
//
//  HdrImg    : R,V,B Img HDR non compresse
//  HdrLumIn  : HdrImg Luminance non compresse [0::1] 
//  HdrLumOut : HdrImg Luminance compresse
//          
//----------------------------------------------------------
void DisplayHDR::HDR_BuiltColorCompressedImg_(float*** HdrImg,float** HdrLumIn,float** HdrLumOut, \
int lgth,int wdth,float*** ImgCoul,float sat)
{ 
 int i,j,k;
 float tmp;

 //Presentation
 printf("\n > ColorModel -2-");
 fflush(stdout);

 //>Conversion
 //=================
 for(k=0;k<TROIS;k++)
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
       { tmp=0.0;
         if (HdrLumIn[i][j]) 
                { tmp=(HdrImg[k][i][j]/HdrLumIn[i][j])-1.0;
	          ImgCoul[k][i][j]=((tmp*sat)+1)*HdrLumOut[i][j]; }
         else ImgCoul[k][i][j]=0.0;
       }

 //Recalage [0::255] de RVB
 //========================
 HDR_RecalWithSat(ImgCoul[0],lgth,wdth,255,PIXSAT);
 HDR_RecalWithSat(ImgCoul[1],lgth,wdth,255,PIXSAT);
 HDR_RecalWithSat(ImgCoul[2],lgth,wdth,255,PIXSAT); 
}

//=================================
//=================================
//  SPECIFICATION HISTOGRAMME
//=================================
//=================================
//----------------------------------------------------------
//  HDR >> HDR_Histo
//----------------------------------------------------------
//  HISTO(k/s,p) :: Rectangle 
//
//  NOTA: plus k est grand:: plus de details
// 
//----------------------------------------------------------     
float DisplayHDR::HDR_Histo(float k)
{
  if (k<GRADMAX) return 1.0;
  else return 0.0;
}

//---------------------------------------------------------------------
//  HDR >> SpecHistoGradOnModel
//---------------------------------------------------------------------
//   
//    MODEL :: k \in ]0.0::1.0] en NBBIN_IMG=256 bins
//
//   HistoGrad :: \in [0.0::1.0] en NBBIN_IMG=256 bins
//             :: suivant MODEL DISTRIBUTION
//----------------------------
//
//  TabHistGrad[l][0] :: HistGrad. Val. In < l \in [0::lgth*wdth*(NbCnx-1)] >
//             [l][1] :: (i*wdth)+j
//             [l][2] :: k= 0:: NbCx-1
//             [l][3] :: HistGrad. Val. Out
//  
//---------------------------------------------------------------------     
void DisplayHDR::HDR_SpecHistoGradOnModel_M(float** NLGrph,int NbCx,int lgth,int wdth)
{
 int i,j,k,l,m,n;
 int nbc,nbp,nbdf;
 int NbDiff;
 int NbCols;
 int pos;
 float MinDiff;
 float PropPixs;
 float idxmod;
 float tmp;

 int NbCxMax;
 int NbVois;
 int SzW;
 int SzWd2;
 float dist;

 //Calcul TabPositions
 SzW=(int)sqrt(NbCx);
 SzWd2=(int)(sqrt(NbCx)/2.0);
 NbVois=(int)(sqrt(NbCx)/2.0);
 NbCxMax=8*NbVois;
 
 //Constantes
 NbCols=4;

 //Presentation
 printf("\n\n  >>> HDR_SpecHistoGradOnModel [NbVois::%d]",NbVois);
 printf("\n    --------------------------------------");
 printf("\n");
 fflush(stdout);

 //AllocationMemoire
 int** TabPos=imatrix_allocate_2d(NbVois,NbCxMax);
 float** TabHistGrad=fmatrix_allocate_2d(lgth*wdth*NbCxMax,NbCols);
 float** HistModel=fmatrix_allocate_2d(2,NBBIN_IMG);

 //Initialisation
 for(k=0;k<NbVois;k++) for(l=0;l<NbCxMax;l++) TabPos[k][l]=-1;
 for(k=0;k<lgth*wdth*NbCxMax;k++) for(l=0;l<NbCols;l++) TabHistGrad[k][l]=0.0;
 for(l=0;l<2;l++) for(k=0;k<NBBIN_IMG;k++) HistModel[l][k]=0.0;
 
 //Remplissage TabPos
 for(nbp=0,m=-SzWd2;m<=SzWd2;m++) for(n=-SzWd2;n<=SzWd2;n++)
    { dist=(int)MAX(fabs(m),fabs(n))-1;
      if (dist<0) { nbp++; continue; }
      for(l=0;TabPos[(int)dist][l]>=0;l++)  continue; 
      TabPos[(int)dist][l]=nbp++; }

 //DEBUG
 if (0) { printf("\n");
          for(k=0;k<NbVois;k++) 
             { printf("\n");
               for(l=0;l<NbCxMax;l++)  printf("[%d]",TabPos[k][l]); }
               exit(-1); }

  //==================
  //BOUCLE
  //==================
  for(n=0;n<NbVois;n++)
    {
     printf("\n   [%d] Specification...",n+1);
     fflush(stdout);
     NbDiff=lgth*wdth*(8*(n+1));

           //>RecupVal & FindMinDiff
           MinDiff=10000;
           nbdf=0;
           for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
              { 
               nbp=(i*wdth)+j;
               for(k=0;k<(8*(n+1));k++) 
                  { 
		   pos=TabPos[n][k];
                   //printf("[%d::%d]",k,pos); fflush(stdout);
                   TabHistGrad[nbdf][0]=NLGrph[pos][nbp]; 
                   TabHistGrad[nbdf][1]=nbp;
                   TabHistGrad[nbdf][2]=pos;
                   nbdf++; 
                   if ((NLGrph[pos][nbp])&&(NLGrph[pos][nbp]<MinDiff)) { MinDiff=NLGrph[pos][nbp]; } 
                  }      
	      }
           printf("  > MinDiff=%.10f",MinDiff);
           fflush(stdout);

           //>Add MinDiff/4 Noise
           //if (FLAG_ALEATSORT) 
           for(k=0;k<NbDiff;k++) TabHistGrad[k][0]+=(randomize()*(MinDiff/4.0));

           //>Sort
           printf("  > Sort"); fflush(stdout);
           sort(TabHistGrad,0,NbDiff,NbCols);
           printf("..."); fflush(stdout);

          //>DEBUG
          if (0) for(k=0;k<NbDiff;k++)
                 { printf("\n");
                   for(l=0;l<NbCols;l++) printf("[%f]",TabHistGrad[k][l]); }

          //===============
          //>SPECIFICATION
          //=============== 
          for(k=1;k<=NBBIN_IMG;k++) HistModel[0][k-1]=HDR_Histo((float)(k)/(float)NBBIN_IMG);
          for(tmp=0.0,k=0;k<NBBIN_IMG;k++) tmp+=HistModel[0][k];
          for(k=0;k<NBBIN_IMG;k++) HistModel[0][k]/=tmp;

          HistModel[1][0]=HistModel[0][0];
          for(k=1;k<NBBIN_IMG;k++) HistModel[1][k]=HistModel[1][k-1]+HistModel[0][k];
          printf(" > [Histo. Cum=%.2f]",HistModel[1][NBBIN_IMG-1]);

          for(l=0,nbdf=0,k=0;k<NBBIN_IMG;k++)
             { idxmod=(float)k/(float)NBBIN_IMG;
               PropPixs=(int)((NbDiff*HistModel[1][k]));    
               for(l=nbdf;(l<(PropPixs))&&(l<NbDiff);l++) TabHistGrad[l][3]=idxmod;    
               nbdf=(int)PropPixs; }
 
          printf(" > [GradHisto::%d>%d]",nbdf,NbDiff); fflush(stdout);
          for(l=nbdf;l<NbDiff;l++) if (!TabHistGrad[l][3]) TabHistGrad[l][3]=TabHistGrad[l-1][3];
          //=============================================

          //>DEBUG
          if (0) for(k=0;k<NbDiff;k++)
                 { printf("\n");
                   for(l=0;l<NbCols;l++) printf("[%f]",TabHistGrad[k][l]); }

          //============================================
          //>TRANSFERT>NLGrph
          //
          // TabHistGrad[l][1] :: (i*wdth)+j
          //            [l][2] :: k= 0:: NbCx-1
          //            [l][3] :: HistGrad. Val. Out
          //============================================
          for(l=0;l<NbDiff;l++)
             { nbp=(int)TabHistGrad[l][1];
               nbc=(int)TabHistGrad[l][2];  
               idxmod=TabHistGrad[l][3];
               NLGrph[nbc][nbp]=idxmod; }
          //============================================

    }//==========================================================================

 //LiberationMemoire
 if (TabHistGrad) free_fmatrix_2d(TabHistGrad);
 if (HistModel)   free_fmatrix_2d(HistModel); 
 if (TabPos)      free_imatrix_2d(TabPos);
}

//----------------------------------------------------------
//  HDR >> ExactSpecifGaussModel
//----------------------------------------------------------
//   
// Nota : Result in [0.0::1.0]
//----------------------------------------------------------     
void DisplayHDR::HDR_ExactSpecifGaussModel(float** HdrImgIn,float** HdrImgOut,int lgth,int wdth)
{
  int i,j,k,l;
 int nbp;
 int NbPixs;
 int NbCols;
 int posr,posc;
 float ng;
 float MinDiff;
 float tmp;
 float PropPixs;
 float idxmod;

 //Constantes
 NbPixs=lgth*wdth;
 NbCols=4;

 //AllocationMemoire
 float** TabHist=fmatrix_allocate_2d(NbPixs,4);
 float** HistModel=fmatrix_allocate_2d(2,NBBIN_IMG);

 //Recal
 RecalI(HdrImgIn,lgth,wdth,0.0,1.0);

 //>RecupValNg
 MinDiff=10000;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { nbp=(i*wdth)+j;
     TabHist[nbp][0]=HdrImgIn[i][j];
     TabHist[nbp][1]=i;
     TabHist[nbp][2]=j; 
     if ((HdrImgIn[i][j])&&(HdrImgIn[i][j]<MinDiff)) MinDiff=HdrImgIn[i][j]; }

 printf("\n  > MinDiff=%.10f",MinDiff);

 //>Add MinDiff/4 Noise
 if (FLAG_ALEATSORT) for(k=0;k<NbPixs;k++) TabHist[k][0]+=(randomize()*(MinDiff/4.0));  
 
  //>Sort
 printf("\n  > Sort ..."); fflush(stdout);
 sort(TabHist,0,NbPixs,NbCols);
 printf("..."); fflush(stdout);

 //>SPECIFICATION
 //========================================
 for(k=0;k<=NBBIN_IMG;k++) HistModel[0][k]=funcgauss((float)k/NBBIN_IMG,MOYGAUSS,VARGAUSS);
 for(tmp=0.0,k=0;k<NBBIN_IMG;k++) tmp+=HistModel[0][k];
 for(k=0;k<NBBIN_IMG;k++) HistModel[0][k]/=tmp;

 HistModel[1][0]=HistModel[0][0];
 for(k=1;k<NBBIN_IMG;k++) HistModel[1][k]=HistModel[1][k-1]+HistModel[0][k];
 printf("\n  > [Histo. Cum=%.3f]",HistModel[1][NBBIN_IMG-1]);

 for(l=0,nbp=0,k=0;k<NBBIN_IMG;k++)
   { idxmod=(float)k/(float)NBBIN_IMG;
     PropPixs=(int)((NbPixs*HistModel[1][k]));    
     for(l=nbp;(l<(PropPixs))&&(l<NbPixs);l++) TabHist[l][3]=idxmod;    
     nbp=(int)PropPixs; }
 
 printf("\n  > [Histo::::%d>%d]",nbp,NbPixs); fflush(stdout);
 for(l=nbp;l<NbPixs;l++) if (!TabHist[l][3]) TabHist[l][3]=TabHist[l-1][3];
 //=============================================

 //>TRANSFERT>
 //===========
 for(l=0;l<NbPixs;l++)
   { ng=TabHist[l][3];
     posr=(int)TabHist[l][1];
     posc=(int)TabHist[l][2]; 
     HdrImgOut[posr][posc]=ng; }

 //LiberationMemoire
 if (TabHist) free_fmatrix_2d(TabHist);
 if (HistModel)   free_fmatrix_2d(HistModel); 
} 


//----------------------------------------------------------
//  HDR >> HDR_ComputeHisto
//----------------------------------------------------------
//   
// Nota: HdrImg in [0.0::1.0]
//       Modele in [0.0::1.0]
//
// Verif. posteriori
//  
//----------------------------------------------------------     
void DisplayHDR::HDR_ComputeHisto(float** HdrImg,int lgth,int wdth)
{
 int i,j,k;
 float tmp;
 float mean,var;

 //Presentation  
 printf("\n\n\n  >> Calcul Histo Img-Hdr");
 printf("\n     --------------------\n");

 //Allocation Memoire
 float* HistoGrad=fmatrix_allocate_1d(NBBIN_IMG);
 
 //Calcul Histogramme Ng
 for(i=0;i<NBBIN_IMG;i++) HistoGrad[i]=0.0;

 //>Histo Grad Hdr_In
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { tmp=NBBIN_IMG*fabs(HdrImg[i+1][j]-HdrImg[i][j]);
     HistoGrad[(int)(tmp)]++;
     tmp=NBBIN_IMG*fabs(HdrImg[i][j+1]-HdrImg[i][j]);
     HistoGrad[(int)(tmp)]++;
     tmp=NBBIN_IMG*fabs(HdrImg[i+1][j+1]-HdrImg[i][j]);
     HistoGrad[(int)(tmp)]++; }

    for(tmp=0.0,k=0;k<NBBIN_IMG;k++) tmp+=HistoGrad[k];
    for(k=0;k<NBBIN_IMG;k++) HistoGrad[k]/=tmp;

 //Affiche Resultat
 printf("  >>HISTO> ");
 for(k=0;k<0.1*NBBIN_IMG;k++) { printf("[%d:%.4f]",k,HistoGrad[k]); fflush(stdout); }

 //DEBUG
 if (0) for(k=0;k<NBBIN_IMG;k++) printf("\n%f",HistoGrad[k]);

 //Variance
 mean=0.0;
 for(k=0;k<NBBIN_IMG;k++) mean+=((float)k/NBBIN_IMG)*HistoGrad[k];
 var=0.0;
 for(k=0;k<NBBIN_IMG;k++) var+=CARRE(((float)k/NBBIN_IMG)-mean)*HistoGrad[k];
 printf("\n <<Variance=%.8f>>>",var);

 //Affiche Model ]0.0::1.0]
 printf("\n\n");
 for(k=1;k<NBBIN_IMG;k++) HistoGrad[k-1]=HDR_Histo(((float)k/(float)NBBIN_IMG)); 
 for(tmp=0.0,k=0;k<NBBIN_IMG;k++) tmp+=HistoGrad[k];
 for(k=0;k<NBBIN_IMG;k++) HistoGrad[k]/=tmp;
 printf("  >>MODEL> ");
 for(k=0;k<0.1*NBBIN_IMG;k++) {  printf("[%d:%.4f]",k,HistoGrad[k]);  fflush(stdout); }

 //Liberation Memoire
 if (HistoGrad)  free_fmatrix_1d(HistoGrad); 
}

//=================================
//=================================
//  INFO
//=================================
//=================================
//----------------------------------------------------------
// HDR_Stat           
//----------------------------------------------------------     
void DisplayHDR::HDR_Stat(float** Img,int lgth,int wdth)
{
 int i,j;
 float min,max,moy; 

 //Stats
 min=10000000.0;
 max=-10000000.0;
 moy=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { moy+=Img[i][j];
      if(min>Img[i][j]) min=Img[i][j]; 
      if(max<Img[i][j]) max=Img[i][j];  }
  moy/=(lgth*wdth);
  printf("\n Stat::[min=%.8f | max=%.8f | Moy=%.8f]",min,max,moy);
  fflush(stdout);
}

//----------------------------------------------------------
// HDR_VisuHisto           
//----------------------------------------------------------     
void DisplayHDR::HDR_VisuHisto(float** Img,int lgth,int wdth)
{
  int i,j,k;

 //Allocation Memoire
 float* TabHist=fmatrix_allocate_1d(NBBIN_IMG);

 //Stats
 for(k=0;k<NBBIN_IMG;k++)  TabHist[k]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabHist[(int)Img[i][j]]++;
 for(k=0;k<NBBIN_IMG;k++)  printf("\n[%d::%.0f]",k,TabHist[k]);
 printf("\n\n\n");

 //Liberation
 if (TabHist) free_fmatrix_1d(TabHist);
}

//----------------------------------------------------------
// HDR_FillInfoProcess 
//----------------------------------------------------------    
void DisplayHDR::HDR_FillInfoProcess()
{
 char Buff[NCHAR];

 //>NbVoisinage[Ok]
 sprintf(Buff,"_Ngb%d",NewNeighb);
 strcpy(InfoProcess,Buff);

 //>ParGauss[Ok]
 sprintf(Buff,"_Gs%.2f_%.3f",MOYGAUSS,VARGAUSS);
 strcat(InfoProcess,Buff);

 //>ParGrad[Ok]
 sprintf(Buff,"_Gr%.2f",GRADMAX);
 strcat(InfoProcess,Buff);

 //>StepGrd[Ok]
 sprintf(Buff,"_Sg%.0f",StGrInit*1000);
 strcat(InfoProcess,Buff);
 
 //>Nrj[Ok]
 sprintf(Buff,"_Nj%.0f_%.0f",NrjImgInit,NrjImg);
 strcat(InfoProcess,Buff);

 //>Variance[Ok]
 sprintf(Buff,"_Var%.1f_%.1f",Tau*1000,VarMagnitude*1000);
 strcat(InfoProcess,Buff);

 //>NbIters[Ok]
 sprintf(Buff,"_It%d",NbIterFinal);
 strcat(InfoProcess,Buff);

 //>Time[Ok]
 sprintf(Buff,"_Sc%d",TimeSec);
 strcat(InfoProcess,Buff);

 //>SaturationPixels[Ok]
 sprintf(Buff,"_Sp%.1f",PIXSAT);
 strcat(InfoProcess,Buff);

 //>SaturationColor[Ok]
 sprintf(Buff,"_S%.1f",SATHDR);
 strcat(InfoProcess,Buff);
 
 //>Extension[Ok]
 sprintf(Buff,"_%s",Extension);
 strcat(InfoProcess,Buff);

 //>Display
 printf("\n Extension -> %s",InfoProcess);
}

//=================================
//=================================
//END 
//=================================
//=================================

